var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { DataStore } from '../../../../context/DataStore';
var AppDataStore = (function (_super) {
    __extends(AppDataStore, _super);
    function AppDataStore() {
        return _super.call(this) || this;
    }
    Object.defineProperty(AppDataStore.prototype, "windows", {
        // Every core should have it's own function
        // registered in your datastore
        //
        // If you want to have some UI controls use
        // different subsets of the data in the index
        // you should register one entry per use case.
        get: function () {
            if (!this.core) {
                this.core = _super.prototype.registerCore.call(this, {
                    url: 'http://40.87.64.225:8983/solr/',
                    core: 'glass2',
                    primaryKey: 'id',
                    // Unfortunately these have to be repeated 
                    // since there is no apparent way to sync
                    // this with Typescript
                    fields: [
                        'id', 'url', 'place', 'height', 'width', 'aspect', 'faces',
                        'face_count', 'resnet50_tags', 'gv_labels',
                        'gv_inscription', 'gv_partial_matching_images',
                        'gv_pages_matching_images',
                        'gv_full_matching_images',
                        'train_1', 'train_2', 'train_3', 'train_4', 'train_5',
                        'confidence_1', 'confidence_2', 'confidence_3', 'confidence_4', 'confidence_5',
                        'prediction_1', 'prediction_2', 'prediction_3', 'prediction_4', 'prediction_5',
                    ],
                    fq: ['url', '*'],
                    defaultSearchFields: [
                        'id',
                        'gv_inscription',
                        'resnet50_tags',
                        'gv_labels'
                    ],
                    pageSize: 50,
                    prefix: 'glass'
                });
            }
            return this.core;
        },
        enumerable: true,
        configurable: true
    });
    return AppDataStore;
}(DataStore));
export { AppDataStore };
//# sourceMappingURL=AppDataStore.js.map